--- CVS/cperl-mode.el	2003-02-04 14:24:34.000000000 +0100
+++ pfeiffer/cperl-mode.el	2003-02-11 23:00:28.000000000 +0100
@@ -1,6 +1,6 @@
 ;;; cperl-mode.el --- Perl code editing commands for Emacs
 
-;; Copyright (C) 1985, 86, 87, 91, 92, 93, 94, 95, 96, 1997
+;; Copyright (C) 1985, 86, 87, 91, 92, 93, 94, 95, 96, 1997, 2000, 2003
 ;;     Free Software Foundation, Inc.
 
 ;; Author: Ilya Zakharevich and Bob Olson
@@ -28,38 +28,43 @@
 
 ;;; Commentary:
 
-;;; You can either fine-tune the bells and whistles of this mode or
-;;; bulk enable them by putting
+;; You can either fine-tune the bells and whistles of this mode or
+;; bulk enable them by putting
 
 ;; (setq cperl-hairy t)
 
-;;; in your .emacs file.  (Emacs rulers do not consider it politically
-;;; correct to make whistles enabled by default.)
+;; in your .emacs file.  (Emacs rulers do not consider it politically
+;; correct to make whistles enabled by default.)
 
-;;; DO NOT FORGET to read micro-docs (available from `Perl' menu)   <<<<<<
-;;; or as help on variables `cperl-tips', `cperl-problems',         <<<<<<
-;;; `cperl-praise', `cperl-speed'.				    <<<<<<
-
-;;; The mode information (on C-h m) provides some customization help.
-;;; If you use font-lock feature of this mode, it is advisable to use
-;;; either lazy-lock-mode or fast-lock-mode.  I prefer lazy-lock.
-
-;;; Faces used now: three faces for first-class and second-class keywords
-;;; and control flow words, one for each: comments, string, labels,
-;;; functions definitions and packages, arrays, hashes, and variable
-;;; definitions.  If you do not see all these faces, your font-lock does
-;;; not define them, so you need to define them manually.
-
-;;; into your .emacs file.
-
-;;;; This mode supports font-lock, imenu and mode-compile.  In the
-;;;; hairy version font-lock is on, but you should activate imenu
-;;;; yourself (note that mode-compile is not standard yet).  Well, you
-;;;; can use imenu from keyboard anyway (M-x imenu), but it is better
-;;;; to bind it like that:
+;; DO NOT FORGET to read micro-docs (available from `Perl' menu)   <<<<<<
+;; or as help on variables `cperl-tips', `cperl-problems',         <<<<<<
+;; `cperl-praise', `cperl-speed'.				   <<<<<<
+
+;; The mode information (on C-h m) provides some customization help.
+;; If you use font-lock feature of this mode, it is advisable to use
+;; either lazy-lock-mode or fast-lock-mode.  I prefer lazy-lock.
+
+;; Faces used now: three faces for first-class and second-class keywords
+;; and control flow words, one for each: comments, string, labels,
+;; functions definitions and packages, arrays, hashes, and variable
+;; definitions.  If you do not see all these faces, your font-lock does
+;; not define them, so you need to define them manually.
+
+;; This mode supports font-lock, imenu and mode-compile.  In the
+;; hairy version font-lock is on, but you should activate imenu
+;; yourself (note that mode-compile is not standard yet).  Well, you
+;; can use imenu from keyboard anyway (M-x imenu), but it is better
+;; to bind it like that:
 
 ;; (define-key global-map [M-S-down-mouse-3] 'imenu)
 
+;;; Font lock bugs:
+
+;; The following kinds of Perl code erroneously start strings:
+;; \$`  \$'  \$"
+;; $opt::s  $opt_s  $opt{s}  (s => ...)  /\s+.../
+;; likewise with m, tr, y, q, qX instead of s
+
 ;;; Code:
 
 ;; Some macros are needed for `defcustom'
@@ -170,8 +175,7 @@
 instead of:
 
 	if () {
-	}
-"
+	}"
   :type 'boolean
   :group 'cperl-autoinsert-details)
 
@@ -354,12 +358,12 @@
   :group 'cperl-affected-by-hairy)
 
 (defcustom cperl-pod-face 'font-lock-comment-face
-  "*Face for pod highlighting."
+  "*Face for POD highlighting."
   :type 'face
   :group 'cperl-faces)
 
 (defcustom cperl-pod-head-face 'font-lock-variable-name-face
-  "*Face for pod highlighting.
+  "*Face for POD highlighting.
 Font for POD headers."
   :type 'face
   :group 'cperl-faces)
@@ -376,7 +380,7 @@
   :group 'cperl-faces)
 
 (defcustom cperl-pod-here-fontify '(featurep 'font-lock)
-  "*Not-nil after evaluation means to highlight pod and here-docs sections."
+  "*Not-nil after evaluation means to highlight POD and here-docs sections."
   :type 'boolean
   :group 'cperl-faces)
 
@@ -395,7 +399,7 @@
   :group 'cperl)
 
 (defcustom cperl-pod-here-scan t
-  "*Not-nil means look for pod and here-docs sections during startup.
+  "*Not-nil means look for POD and here-docs sections during startup.
 You can always make lookup from menu or using \\[cperl-find-pods-heres]."
   :type 'boolean
   :group 'cperl-speed)
@@ -593,7 +597,7 @@
 ;;; Short extra-docs.
 
 (defvar cperl-tips 'please-ignore-this-line
-  "Get newest version of this package from
+  "Get maybe newer version of this package from
   ftp://ftp.math.ohio-state.edu/pub/users/ilya/emacs
 and/or
   ftp://ftp.math.ohio-state.edu/pub/users/ilya/perl
@@ -681,7 +685,7 @@
 
 This may be confusing, since the regexp s#//#/#\; may be highlighted
 as a comment, but it will be recognized as a regexp by the indentation
-code.  Or the opposite case, when a pod section is highlighted, but
+code.  Or the opposite case, when a POD section is highlighted, but
 may break the indentation of the following code (though indentation
 should work if the balance of delimiters is not broken by POD).
 
@@ -699,7 +703,7 @@
 
 If these bugs cannot be fixed on your machine (say, you have an inferior
 environment and cannot recompile), you may still disable all the fancy stuff
-via `cperl-use-syntax-table-text-property'." )
+via `cperl-use-syntax-table-text-property'.")
 
 (defvar cperl-praise 'please-ignore-this-line
   "Advantages of CPerl mode.
@@ -783,8 +787,7 @@
 line-breaks/spacing between elements of the construct.
 
 10) Uses a linear-time algorith for indentation of regions (on Emaxen with
-capable syntax engines).
-")
+capable syntax engines).")
 
 (defvar cperl-speed 'please-ignore-this-line
   "This is an incomplete compendium of what is available in other parts
@@ -828,8 +831,7 @@
     wrongly matched parentheses, wrong indentation, etc.
 
     One can unset `cperl-syntaxify-unwind'.  This might speed up editing
-    of, say, long POD sections.
-")
+    of, say, long POD sections.")
 
 (defvar cperl-tips-faces 'please-ignore-this-line
   "CPerl mode uses following faces for highlighting:
@@ -901,7 +903,7 @@
 (defsubst cperl-enable-font-lock ()
   (or cperl-xemacs-p window-system))
 
-(defun cperl-putback-char (c)	; Emacs 19
+(defun cperl-putback-char (c)		; Emacs 19
   (set 'unread-command-events (list c))) ; Avoid undefined warning
 
 (if (boundp 'unread-command-events)
@@ -926,7 +928,7 @@
   ;; If POST, do not do it with postponed fontification
   (if (and post cperl-syntaxify-by-font-lock)
       nil
-  (put-text-property (max (point-min) (1- from))
+    (put-text-property (max (point-min) (1- from))
 		       to cperl-do-not-fontify t)))
 
 (defcustom cperl-mode-hook nil
@@ -955,24 +957,11 @@
 ;;;     (setq interpreter-mode-alist (append interpreter-mode-alist
 ;;;					  '(("miniperl" . perl-mode))))))
 (eval-when-compile
-  (condition-case nil
-      (require 'imenu)
-    (error nil))
-  (condition-case nil
-      (require 'easymenu)
-    (error nil))
-  (condition-case nil
-      (require 'etags)
-    (error nil))
-  (condition-case nil
-      (require 'timer)
-    (error nil))
-  (condition-case nil
-      (require 'man)
-    (error nil))
-  (condition-case nil
-      (require 'info)
-    (error nil))
+  (mapc (lambda (p)
+	  (condition-case nil
+	      (require p)
+	    (error nil)))
+	'(imenu easymenu etags timer man info))
   (if (fboundp 'ps-extend-face-list)
       (defmacro cperl-ps-extend-face-list (arg)
 	`(ps-extend-face-list ,arg))
@@ -1071,51 +1060,51 @@
     (progn
       (require 'easymenu)
       (easy-menu-define cperl-menu cperl-mode-map "Menu for CPerl mode"
-         '("Perl"
-	   ["Beginning of function" beginning-of-defun t]
-	   ["End of function" end-of-defun t]
-	   ["Mark function" mark-defun t]
-	   ["Indent expression" cperl-indent-exp t]
-	   ["Fill paragraph/comment" cperl-fill-paragraph t]
-	   "----"
-	   ["Line up a construction" cperl-lineup (cperl-use-region-p)]
-	   ["Invert if/unless/while etc" cperl-invert-if-unless t]
-	   ("Regexp"
-	    ["Beautify" cperl-beautify-regexp
-	     cperl-use-syntax-table-text-property]
-	    ["Beautify one level deep" (cperl-beautify-regexp 1)
-	     cperl-use-syntax-table-text-property]
-	    ["Beautify a group" cperl-beautify-level
-	     cperl-use-syntax-table-text-property]
-	    ["Beautify a group one level deep" (cperl-beautify-level 1)
-	     cperl-use-syntax-table-text-property]
-	    ["Contract a group" cperl-contract-level
-	     cperl-use-syntax-table-text-property]
-	    ["Contract groups" cperl-contract-levels
-	     cperl-use-syntax-table-text-property])
-	   ["Refresh \"hard\" constructions" cperl-find-pods-heres t]
-	   "----"
-	   ["Indent region" cperl-indent-region (cperl-use-region-p)]
-	   ["Comment region" cperl-comment-region (cperl-use-region-p)]
-	   ["Uncomment region" cperl-uncomment-region (cperl-use-region-p)]
-	   "----"
-	   ["Run" mode-compile (fboundp 'mode-compile)]
-	   ["Kill" mode-compile-kill (and (fboundp 'mode-compile-kill)
-					  (get-buffer "*compilation*"))]
-	   ["Next error" next-error (get-buffer "*compilation*")]
-	   ["Check syntax" cperl-check-syntax (fboundp 'mode-compile)]
-	   "----"
-	   ["Debugger" cperl-db t]
-	   "----"
-	   ("Tools"
-	    ["Imenu" imenu (fboundp 'imenu)]
-	    ["Insert spaces if needed" cperl-find-bad-style t]
-	    ["Class Hierarchy from TAGS" cperl-tags-hier-init t]
-	    ;;["Update classes" (cperl-tags-hier-init t) tags-table-list]
-	    ["CPerl pretty print (exprmntl)" cperl-ps-print
-	     (fboundp 'ps-extend-face-list)]
-	    ["Imenu on info" cperl-imenu-on-info (featurep 'imenu)]
-	    ("Tags"
+	'("Perl"
+	  ["Beginning of function" beginning-of-defun t]
+	  ["End of function" end-of-defun t]
+	  ["Mark function" mark-defun t]
+	  ["Indent expression" cperl-indent-exp t]
+	  ["Fill paragraph/comment" cperl-fill-paragraph t]
+	  "----"
+	  ["Line up a construction" cperl-lineup (cperl-use-region-p)]
+	  ["Invert if/unless/while etc" cperl-invert-if-unless t]
+	  ("Regexp"
+	   ["Beautify" cperl-beautify-regexp
+	    cperl-use-syntax-table-text-property]
+	   ["Beautify one level deep" (cperl-beautify-regexp 1)
+	    cperl-use-syntax-table-text-property]
+	   ["Beautify a group" cperl-beautify-level
+	    cperl-use-syntax-table-text-property]
+	   ["Beautify a group one level deep" (cperl-beautify-level 1)
+	    cperl-use-syntax-table-text-property]
+	   ["Contract a group" cperl-contract-level
+	    cperl-use-syntax-table-text-property]
+	   ["Contract groups" cperl-contract-levels
+	    cperl-use-syntax-table-text-property])
+	  ["Refresh \"hard\" constructions" cperl-find-pods-heres t]
+	  "----"
+	  ["Indent region" cperl-indent-region (cperl-use-region-p)]
+	  ["Comment region" cperl-comment-region (cperl-use-region-p)]
+	  ["Uncomment region" cperl-uncomment-region (cperl-use-region-p)]
+	  "----"
+	  ["Run" mode-compile (fboundp 'mode-compile)]
+	  ["Kill" mode-compile-kill (and (fboundp 'mode-compile-kill)
+					 (get-buffer "*compilation*"))]
+	  ["Next error" next-error (get-buffer "*compilation*")]
+	  ["Check syntax" cperl-check-syntax (fboundp 'mode-compile)]
+	  "----"
+	  ["Debugger" cperl-db t]
+	  "----"
+	  ("Tools"
+	   ["Imenu" imenu (fboundp 'imenu)]
+	   ["Insert spaces if needed" cperl-find-bad-style t]
+	   ["Class Hierarchy from TAGS" cperl-tags-hier-init t]
+	   ;;["Update classes" (cperl-tags-hier-init t) tags-table-list]
+	   ["CPerl pretty print (exprmntl)" cperl-ps-print
+	    (fboundp 'ps-extend-face-list)]
+	   ["Imenu on info" cperl-imenu-on-info (featurep 'imenu)]
+	   ("Tags"
 ;;;	     ["Create tags for current file" cperl-etags t]
 ;;;	     ["Add tags for current file" (cperl-etags t) t]
 ;;;	     ["Create tags for Perl files in directory" (cperl-etags nil t) t]
@@ -1125,57 +1114,57 @@
 ;;;	     ["Add tags for Perl files in (sub)directories"
 ;;;	      (cperl-etags t 'recursive) t])
 ;;;; cperl-write-tags (&optional file erase recurse dir inbuffer)
-	     ["Create tags for current file" (cperl-write-tags nil t) t]
-	     ["Add tags for current file" (cperl-write-tags) t]
-	     ["Create tags for Perl files in directory"
-	      (cperl-write-tags nil t nil t) t]
-	     ["Add tags for Perl files in directory"
-	      (cperl-write-tags nil nil nil t) t]
-	     ["Create tags for Perl files in (sub)directories"
-	      (cperl-write-tags nil t t t) t]
-	     ["Add tags for Perl files in (sub)directories"
-	      (cperl-write-tags nil nil t t) t]))
-	   ("Perl docs"
-	    ["Define word at point" imenu-go-find-at-position
-	     (fboundp 'imenu-go-find-at-position)]
-	    ["Help on function" cperl-info-on-command t]
-	    ["Help on function at point" cperl-info-on-current-command t]
-	    ["Help on symbol at point" cperl-get-help t]
-	    ["Perldoc" cperl-perldoc t]
-	    ["Perldoc on word at point" cperl-perldoc-at-point t]
-	    ["View manpage of POD in this file" cperl-pod-to-manpage t]
-	    ["Auto-help on" cperl-lazy-install
-	     (and (fboundp 'run-with-idle-timer)
-		  (not cperl-lazy-installed))]
-	    ["Auto-help off" (eval '(cperl-lazy-unstall))
-	     (and (fboundp 'run-with-idle-timer)
-		  cperl-lazy-installed)])
-	   ("Toggle..."
-	    ["Auto newline" cperl-toggle-auto-newline t]
-	    ["Electric parens" cperl-toggle-electric t]
-	    ["Electric keywords" cperl-toggle-abbrev t]
-	    ["Fix whitespace on indent" cperl-toggle-construct-fix t]
-	    ["Auto fill" auto-fill-mode t])
-	   ("Indent styles..."
-	    ["CPerl" (cperl-set-style "CPerl") t]
-	    ["PerlStyle" (cperl-set-style "PerlStyle") t]
-	    ["GNU" (cperl-set-style "GNU") t]
-	    ["C++" (cperl-set-style "C++") t]
-	    ["FSF" (cperl-set-style "FSF") t]
-	    ["BSD" (cperl-set-style "BSD") t]
-	    ["Whitesmith" (cperl-set-style "Whitesmith") t]
-	    ["Current" (cperl-set-style "Current") t]
-	    ["Memorized" (cperl-set-style-back) cperl-old-style])
-	   ("Micro-docs"
-	    ["Tips" (describe-variable 'cperl-tips) t]
-	    ["Problems" (describe-variable 'cperl-problems) t]
-	    ["Speed" (describe-variable 'cperl-speed) t]
-	    ["Praise" (describe-variable 'cperl-praise) t]
-	    ["Faces" (describe-variable 'cperl-tips-faces) t]
-	    ["CPerl mode" (describe-function 'cperl-mode) t]
-	    ["CPerl version"
-	     (message "The version of master-file for this CPerl is %s-emacs"
-		      cperl-version) t]))))
+	    ["Create tags for current file" (cperl-write-tags nil t) t]
+	    ["Add tags for current file" (cperl-write-tags) t]
+	    ["Create tags for Perl files in directory"
+	     (cperl-write-tags nil t nil t) t]
+	    ["Add tags for Perl files in directory"
+	     (cperl-write-tags nil nil nil t) t]
+	    ["Create tags for Perl files in (sub)directories"
+	     (cperl-write-tags nil t t t) t]
+	    ["Add tags for Perl files in (sub)directories"
+	     (cperl-write-tags nil nil t t) t]))
+	  ("Perl docs"
+	   ["Define word at point" imenu-go-find-at-position
+	    (fboundp 'imenu-go-find-at-position)]
+	   ["Help on function" cperl-info-on-command t]
+	   ["Help on function at point" cperl-info-on-current-command t]
+	   ["Help on symbol at point" cperl-get-help t]
+	   ["Perldoc" cperl-perldoc t]
+	   ["Perldoc on word at point" cperl-perldoc-at-point t]
+	   ["View manpage of POD in this file" cperl-pod-to-manpage t]
+	   ["Auto-help on" cperl-lazy-install
+	    (and (fboundp 'run-with-idle-timer)
+		 (not cperl-lazy-installed))]
+	   ["Auto-help off" (eval '(cperl-lazy-unstall))
+	    (and (fboundp 'run-with-idle-timer)
+		 cperl-lazy-installed)])
+	  ("Toggle..."
+	   ["Auto newline" cperl-toggle-auto-newline t]
+	   ["Electric parens" cperl-toggle-electric t]
+	   ["Electric keywords" cperl-toggle-abbrev t]
+	   ["Fix whitespace on indent" cperl-toggle-construct-fix t]
+	   ["Auto fill" auto-fill-mode t])
+	  ("Indent styles..."
+	   ["CPerl" (cperl-set-style "CPerl") t]
+	   ["PerlStyle" (cperl-set-style "PerlStyle") t]
+	   ["GNU" (cperl-set-style "GNU") t]
+	   ["C++" (cperl-set-style "C++") t]
+	   ["FSF" (cperl-set-style "FSF") t]
+	   ["BSD" (cperl-set-style "BSD") t]
+	   ["Whitesmith" (cperl-set-style "Whitesmith") t]
+	   ["Current" (cperl-set-style "Current") t]
+	   ["Memorized" (cperl-set-style-back) cperl-old-style])
+	  ("Micro-docs"
+	   ["Tips" (describe-variable 'cperl-tips) t]
+	   ["Problems" (describe-variable 'cperl-problems) t]
+	   ["Speed" (describe-variable 'cperl-speed) t]
+	   ["Praise" (describe-variable 'cperl-praise) t]
+	   ["Faces" (describe-variable 'cperl-tips-faces) t]
+	   ["CPerl mode" (describe-function 'cperl-mode) t]
+	   ["CPerl version"
+	    (message "The version of master-file for this CPerl is %s-emacs"
+		     cperl-version) t]))))
   (error nil))
 
 (autoload 'c-macro-expand "cmacexp"
@@ -1186,9 +1175,9 @@
 (defvar cperl-imenu--function-name-regexp-perl
   (concat
    "^\\("
-       "[ \t]*\\(sub\\|package\\)[ \t\n]+\\([a-zA-Z_0-9:']+\\)[ \t]*\\(([^()]*)[ \t]*\\)?"
-     "\\|"
-       "=head\\([12]\\)[ \t]+\\([^\n]+\\)$"
+	"[ \t]*\\(sub\\|package\\)[ \t\n]+\\([a-zA-Z_0-9:']+\\)[ \t]*\\(([^()]*)[ \t]*\\)?"
+   "\\|"
+	"=head\\([12]\\)[ \t]+\\([^\n]+\\)$"
    "\\)"))
 
 (defvar cperl-outline-regexp
@@ -1224,8 +1213,7 @@
   (modify-syntax-entry ?| "." cperl-mode-syntax-table)
   (setq cperl-string-syntax-table (copy-syntax-table cperl-mode-syntax-table))
   (modify-syntax-entry ?$ "." cperl-string-syntax-table)
-  (modify-syntax-entry ?# "." cperl-string-syntax-table) ; (?# comment )
-)
+  (modify-syntax-entry ?# "." cperl-string-syntax-table)) ; (?# comment )
 
 
 
@@ -1337,7 +1325,7 @@
 span the needed amount of lines.
 
 Variables `cperl-pod-here-scan', `cperl-pod-here-fontify',
-`cperl-pod-face', `cperl-pod-head-face' control processing of pod and
+`cperl-pod-face', `cperl-pod-head-face' control processing of POD and
 here-docs sections.  With capable Emaxen results of scan are used
 for indentation too, otherwise they are used for highlighting only.
 
@@ -1502,9 +1490,9 @@
 	;; Fix broken font-lock:
 	(or (boundp 'font-lock-unfontify-region-function)
 	    (set 'font-lock-unfontify-region-function
-		  'font-lock-default-unfontify-region))
+		 'font-lock-default-unfontify-region))
 	(make-local-variable 'font-lock-unfontify-region-function)
-	(set 'font-lock-unfontify-region-function
+	(setq font-lock-unfontify-region-function
 	      'cperl-font-lock-unfontify-region-function)
 	(make-local-variable 'cperl-syntax-done-to)
 	;; Another bug: unless font-lock-syntactic-keywords, font-lock
@@ -1531,12 +1519,9 @@
   (run-hooks 'cperl-mode-hook)
   ;; After hooks since fontification will break this
   (if cperl-pod-here-scan
-      (or ;;(and (boundp 'font-lock-mode)
-	  ;;     (eval 'font-lock-mode)	; Avoid warning
-	  ;;     (boundp 'font-lock-hot-pass) ; Newer font-lock
-       cperl-syntaxify-by-font-lock  ;;)
-       (progn (or cperl-faces-init (cperl-init-faces-weak))
-	      (cperl-find-pods-heres)))))
+      (unless cperl-syntaxify-by-font-lock
+	(or cperl-faces-init (cperl-init-faces-weak))
+	(cperl-find-pods-heres))))
 
 ;; Fix for perldb - make default reasonable
 (defun cperl-db ()
@@ -1546,10 +1531,10 @@
 				(if (consp gud-perldb-history)
 				    (car gud-perldb-history)
 				  (concat "perl " ;;(file-name-nondirectory
-						   ;; I have problems
-						   ;; in OS/2
-						   ;; otherwise
-						   (buffer-file-name)))
+					  ;; I have problems
+					  ;; in OS/2
+					  ;; otherwise
+					  (buffer-file-name)))
 				nil nil
 				'(gud-perldb-history . 1))))
 
@@ -1675,7 +1660,7 @@
 	    (setq last-command-char ?\{)
 	    (cperl-electric-lbrace arg insertpos))
 	  (forward-char 1))
-      ;: Check whether we close something "usual" with `}'
+      ;; Check whether we close something "usual" with `}'
       (if (and (eq last-command-char ?\})
 	       (not
 		(condition-case nil
@@ -1725,17 +1710,17 @@
 (defun cperl-electric-lbrace (arg &optional end)
   "Insert character, correct line's indentation, correct quoting by space."
   (interactive "P")
-  (let (pos after
-	    (cperl-brace-recursing t)
-	    (cperl-auto-newline cperl-auto-newline)
-	    (other-end (or end
-			   (if (and cperl-electric-parens-mark
-				    (cperl-mark-active)
-				    (> (mark) (point)))
-			       (save-excursion
-				 (goto-char (mark))
-				 (point-marker))
-			     nil))))
+  (let ((cperl-brace-recursing t)
+	(cperl-auto-newline cperl-auto-newline)
+	(other-end (or end
+		       (if (and cperl-electric-parens-mark
+				(cperl-mark-active)
+				(> (mark) (point)))
+			   (save-excursion
+			     (goto-char (mark))
+			     (point-marker))
+			 nil)))
+	pos after)
     (and (cperl-val 'cperl-electric-lbrace-space)
 	 (eq (preceding-char) ?$)
 	 (save-excursion
@@ -1768,9 +1753,9 @@
 	(other-end (if (and cperl-electric-parens-mark
 			    (cperl-mark-active)
 			    (> (mark) (point)))
-			   (save-excursion
-			     (goto-char (mark))
-			     (point-marker))
+		       (save-excursion
+			 (goto-char (mark))
+			 (point-marker))
 		     nil)))
     (if (and (cperl-val 'cperl-electric-parens)
 	     (memq last-command-char
@@ -1822,9 +1807,9 @@
 	  (insert (make-string
 		   (prefix-numeric-value arg)
 		   (cdr (assoc last-command-char '((?\} . ?\{)
-						  (?\] . ?\[)
-						  (?\) . ?\()
-						  (?\> . ?\<))))))
+						   (?\] . ?\[)
+						   (?\) . ?\()
+						   (?\> . ?\<))))))
 	  (goto-char (1+ p)))
       (self-insert-command (prefix-numeric-value arg)))))
 
@@ -1879,8 +1864,7 @@
  	     (insert "\n}")
 	     (and do (insert " while ();")))
  	    (t
- 	     (insert (if do " {\n} while ();" " () {\n}")))
- 	    )
+ 	     (insert (if do " {\n} while ();" " () {\n}"))))
 	   (or (looking-at "[ \t]\\|$") (insert " "))
 	   (cperl-indent-line)
 	   (if dollar (progn (search-backward "$")
@@ -1943,7 +1927,7 @@
 			   (save-excursion
 			     (forward-char -1)
 			     (re-search-backward "\\(\\`\n?\\|\n\n\\)=head1\\>"
-						nil t)))) ; Only one
+						 nil t)))) ; Only one
 		     (progn
 		       (forward-word 1)
 		       (setq name (file-name-sans-extension
@@ -2000,8 +1984,7 @@
  	     (cperl-indent-line)
  	     (insert "\n\n}"))
  	    (t
- 	     (insert " {\n\n}"))
- 	    )
+ 	     (insert " {\n\n}")))
 	   (or (looking-at "[ \t]\\|$") (insert " "))
 	   (cperl-indent-line)
 	   (forward-line -1)
@@ -2021,7 +2004,7 @@
     (if (and				; Check if we need to split:
 					; i.e., on a boundary and inside "{...}"
 	 (save-excursion (cperl-to-comment-or-eol)
-	   (>= (point) pos))		; Not in a comment
+			 (>= (point) pos)) ; Not in a comment
 	 (or (save-excursion
 	       (skip-chars-backward " \t" beg)
 	       (forward-char -1)
@@ -2058,7 +2041,7 @@
 	  (cperl-indent-line)
 	  (beginning-of-line)
 	  (or (looking-at "[ \t]*}[,; \t]*$") ; If there is a statement
-					    ; after, move it to separate line
+					; after, move it to separate line
 	      (progn
 		(end-of-line)
 		(search-backward "}" beg)
@@ -2077,7 +2060,7 @@
 	     (save-excursion
 	       (skip-chars-backward " \t")
 	       (eq (preceding-char) ?\)))) ; Probably if () {} group
-					   ; with an extra newline.
+					; with an extra newline.
 	(forward-line 2)
 	(cperl-indent-line))
        ((save-excursion			; In POD header
@@ -2129,10 +2112,11 @@
 (defun cperl-electric-terminator (arg)
   "Insert character and correct line's indentation."
   (interactive "P")
-  (let (insertpos (end (point))
-		  (auto (and cperl-auto-newline
-			     (or (not (eq last-command-char ?:))
-				 cperl-auto-newline-after-colon))))
+  (let ((end (point))
+	(auto (and cperl-auto-newline
+		   (or (not (eq last-command-char ?:))
+		       cperl-auto-newline-after-colon)))
+	insertpos)
     (if (and ;;(not arg)
 	     (eolp)
 	     (not (save-excursion
@@ -2251,9 +2235,9 @@
 (defun cperl-indent-line (&optional parse-data)
   "Indent current line as Perl code.
 Return the amount the indentation changed by."
-  (let (indent i beg shift-amt
-	(case-fold-search nil)
-	(pos (- (point-max) (point))))
+  (let ((case-fold-search nil)
+	(pos (- (point-max) (point)))
+	indent i beg shift-amt)
     (setq indent (cperl-calculate-indent parse-data)
 	  i indent)
     (beginning-of-line)
@@ -2331,7 +2315,7 @@
       (or state (setq state (parse-partial-sexp start start-point -1 nil start-state)))
       (list start state depth prestart))))
 
-(defun cperl-block-p ()			; Do not C-M-q !  One string contains ";" !
+(defun cperl-block-p ()		   ; Do not C-M-q !  One string contains ";" !
   ;; Positions is before ?\{.  Checks whether it starts a block.
   ;; No save-excursion!
   (cperl-backward-to-noncomment (point-min))
